local strings = {}
do
  strings[1] = '0'
  strings[2] = '1'
  strings[3] = '01'
  strings[4] = '001'
  strings[5] = '0001'
  strings[6] = '00001'
  strings[7] = '01001'
  strings[8] = '010001'
  strings[9] = '0010001'
  strings[10] = '0010101'
  strings[11] = '00100101'
  strings[12] = '010010001'
  strings[13] = '0010010001'
  strings[14] = '0010010101'
  strings[15] = '00100100101'
  strings[16] = '00101010101'
  strings[17] = '0010010010001'
  strings[18] = '0101001001001'
  strings[19] = '0101010101001'
  strings[20] = '01010101001001'
  strings[21] = ''
  strings[22] = '01010101010111'
  strings[23] = ''
  strings[24] = '01001010010100101'
end

-- strided list: duration, note
local partiture = {
  3,1,
  3,19, 1,20, 1,19, 1,16, 3,12, 1,1,
    1,13, 1,12, 1,11, 1,12, 1,13, 1,12, 1,18, 1,16, 4,13, 2,1,

  3,18, 1,19, 1,18, 1,16, 3,13, 1,1,
    1,14, 1,13, 1,12, 1,13, 1,14, 1,13, 1,18, 1,13, 4,19, 2,1,

  3,19, 1,20, 1,19, 1,16, 3,12, 1,1,
    1,13, 1,12, 1,11, 1,12, 1,13, 1,12, 1,19, 1,16, 4,14, 2,1,

  3,14, 1,22, 1,18, 1,14, 3,16, 1,1,
    1,9, 1,10, 1,11, 1,12, 1,13, 1,14, 1,13, 1,11, 1,12, .5,1,

  .5,16, .5,1, .5,17, .5,16, .5,15, .5,1, .5,16, .5*3,1,
    .5,13, .5,1, .5,12,
}

--[[
local str2bin = {}
for i = 0, 255 do
  local byte = ''
  local num = i
  for bit = 0, 7 do
    if num >= 128 then
      num = num - 128
      byte = byte .. '1'
    else
      byte = byte .. '0'
    end
    num = num * 2
  end
  str2bin[byte] = i
end
--]]

local BPM = 240 -- beats per minute
local timefactor = 60/BPM -- seconds per beat

local f = io.open(arg[1], 'wb')
do -- try..finally
  local ok, msg = pcall(function ()
    local byte = 1
    local runlength = 0

    local function outbit(b)
      byte = byte * 2
      if b == 1 or b == '1' then
        byte = byte + 1
        runlength = runlength + 0.001 -- 1 KHz for 1
      else
        runlength = runlength + 0.0005 -- 2 KHz for 0
      end
      if byte >= 256 then
        f:write(string.char(byte - 256))
        byte = 1
      end
    end

    local i = 1
    while i <= #partiture do
      local duration = partiture[i] * timefactor
      local note = strings[partiture[i + 1]]
      local ptr = 1

      while runlength < duration do
        outbit(note:byte(ptr) - 48)
        ptr = ptr % #note + 1
      end
      runlength = runlength - duration

      i = i + 2
    end

    -- flush last byte
    while byte ~= 1 do outbit(0) end
  end)

  f:close()
  assert(ok, msg)
end
